/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor qwertz.c */

#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "windows.h"
#include "barvy.h"

static void vypis_qwertz(WINDOW * sub_hlavni, type_nastaveni * nastaveni);

void qwertz(type_nastaveni * nastaveni)
{
    int ch;
    char pomocn[31];
    WINDOW *qwin;

    qwin = sub_hlavni;
    vypis_qwertz(qwin, nastaveni);

    pomocn[0] = '\0';
    do {
        ch = wzadej_text(qwin, pomocn, sizeof(pomocn) / sizeof(char),
                         13, 30, 1, 0);
        if (!ch)
            break;              /* chyba vstupu */

        if (ch == KEY_DOWN) {
            if (!nastaveni->qwertz && !nastaveni->us)
                nastaveni->us = 1;
            else if (!nastaveni->qwertz && nastaveni->us) {
                nastaveni->qwertz = 1;
            } else if (nastaveni->us) {
                nastaveni->us = 0;
            } else
                nastaveni->qwertz = 0;
        }

        if (ch == KEY_UP) {
            if (!nastaveni->qwertz && !nastaveni->us)
                nastaveni->qwertz = 1;
            else if (!nastaveni->qwertz && nastaveni->us) {
                nastaveni->us = 0;
            } else if (nastaveni->us) {
                nastaveni->qwertz = 0;
            } else
                nastaveni->us = 1;
        }

        global_set(g_qwertz, nastaveni->qwertz ? g_q_z : g_q_y);
        global_set(g_us, nastaveni->us ? g_us_us : g_us_cz);
        vypis_qwertz(qwin, nastaveni);
    }
    while (ch != '\n');

    if (uloz_nastaveni(nastaveni))
        print_hl(2, "CHYBA: data se nepodailo uloit do souboru ",
                 jmeno_souboru_nastaveni());
}

static void vypis_qwertz(WINDOW * sub_hlavni, type_nastaveni * nastaveni)
{
    short int i;
    char *sprava[] = {
        "      Zde  si mete  nastavit, zda budete  pouvat  klvesovou",
        " mapu qwertz nebo qwerty, eskou (cz) nebo anglickou (us). Volbu",
        " qwertz/y nastavte dle poteb vuky; cz/us dle systmu a to tak,",
        " aby jste mohli pst 蹾 atp.."
    };

    char *z[6] = { "\tzzzzzzzz",
        "\tzz  zzz ",
        "\t   zzz  ",
        "\t  zzz   ",
        "\tzzz   zz",
        "\tzzzzzzzz"
    };

    char *y[6] = {
        "\tyy    yy",
        "\t yy  yy ",
        "\t  yyyy  ",
        "\t   yy   ",
        "\t   yy   ",
        "\t  yyyy  "
    };

    werase2(sub_hlavni);
    obnov_hlavni();

    for (i = 0; i < sizeof(sprava) / sizeof(sprava[0]); i++)
        mvwprintw2(sub_hlavni, 2 + i, 1, sprava[i]);
    wattron2(sub_hlavni, A_BOLD);
    for (i = 0; i < 6; i++)
        mvwprintw2(sub_hlavni, 6 + i, 1,
                   (nastaveni->qwertz) ? z[i] : y[i]);
    wattroff2(sub_hlavni, A_BOLD);

    mvwprintw2(sub_hlavni, 7, 20, "    qwerz/qwerty");
    mvwprintw2(sub_hlavni, 8, 20, "         a");
    mvwprintw2(sub_hlavni, 9, 20, "       us/cz");
    mvwprintw2(sub_hlavni, 10, 20, "mnte pomoc \"ipek\"");
    mvwprintw2(sub_hlavni, 11, 20, "   nahoru a dol");

    wattron2(sub_hlavni, A_BOLD);
    if (nastaveni->us) {
        mvwprintw2(sub_hlavni, 7, 45, " _   _    ___");
        mvwprintw2(sub_hlavni, 8, 45, "( ) ( ) /',__)");
        mvwprintw2(sub_hlavni, 9, 45, "| (_) | \\__, \\");
        mvwprintw2(sub_hlavni, 10, 45, "`\\___/' (____/");
    } else {
        mvwprintw2(sub_hlavni, 7, 45, "   ___   ____");
        mvwprintw2(sub_hlavni, 8, 45, " /'___) (_  ,)");
        mvwprintw2(sub_hlavni, 9, 45, "( (___   /'/_");
        mvwprintw2(sub_hlavni, 10, 45, "`\\____) (____)");

    }
    wattroff2(sub_hlavni, A_BOLD);

    mvwprintw2(sub_hlavni, 13, 2, "Vyzkouejte si klvesnici: ");
    mvwprintw2(sub_hlavni, 0, 1, "<ENTER> = nvrat do hlavnho menu");

    tiskni_dle_priority();
}
