#ifndef _STRUKTURY_H
#define _STRUKTURY_H
#include <time.h>
#define PBADRESAR "sallyx"
#define JMENO_SOUBORU "slozka.dat"
#define JMENO_SOUBORU_NASTAVENI "nastaveni.dat"

#define RADEK  75
#define STRING_MAX 512
#ifndef NAME_MAX
#define NAME_MAX STRING_MAX
#endif
#define PW_LEN 25
#define UZ_LEN 25
#define MAXLEKCE  100
extern unsigned int LEKCE;      /* pocet lekci (ze souboru napoveda/menu) */
extern unsigned int TEST;       /* pocet testu (ze souboru napoveda/menu) */
extern unsigned int LEKCER;     /* prvni lekce na zvysovani rychlosti */
extern unsigned int TESTR;      /* prvni test na --||-- */
#define MAXODSTAVEC 11
#define MAXTEST   80
#define POKUSU 3
#define BUTTON_MAX 2

#define HLPRINTLINES  (LINES - 5 - ((LINES - 25) * 0.25))
typedef unsigned char boolean;

typedef struct {
    int lekce;
    unsigned int odstavcu;
    unsigned int radku;
    unsigned int znaku;
    unsigned int akt_odstavec;
    unsigned int oradek;        /* v akt_odstavec */
    unsigned int oznaku;        /* v akt_odstavec */
    int mezernik;               /* 1 = ukoncovani radku i mezernikem */
} type_odstavec;

typedef struct {
    unsigned int presnost[5];
    unsigned int rychlost[5];
    int napsano;
    int zavislost;              /* lze nebo nelze tuto lekci psat?
                                   0 = nelze, 1 = lze */
    boolean test;               /* 1 = je to info pro test, 0 = pro lekci */
    int zavislost_na;           /* lekce na jakem testu a naopak */
    int cislo;
    char *komentar;
    char *klavesy;
    char *pismena;
    char *nove_pismena;
    int mezernik;               /* 1 = ukoncovani radku i mezernikem */
} type_informace;

typedef struct {
    unsigned int presnost[5];
    unsigned int rychlost[5];
    short int test;             /* zobrazovani psaneho radku 0 = ano / 1 = ne */
    short int mezernik;         /* 1 = ukoncovani i mezernikem */
} type_vtext;

typedef struct {
    char verse[10];
    short int metronom;
    type_vtext vtext;           /* volny_text */
    short int qwertz;
    short int us;
    short int ZATIM_NIC;
    signed int spusteno;        /* pocet spusteni programu;  */
    short int ZATIM_NIC2;
} type_nastaveni;

typedef struct {
    char verse[10];
    short int napsano_odstavec[MAXLEKCE];
    short int napsano_lekce[MAXLEKCE];

    short int napsano_test[MAXTEST];
    time_t datum_test[POKUSU][MAXTEST]; /* kdy byl test psan */

    short int uh_min[POKUSU][MAXTEST];
    unsigned short int chyb_test[POKUSU][MAXTEST];
    unsigned short int vterin_test[POKUSU][MAXTEST];
    float znamka_test[POKUSU][3][MAXTEST];

    char jmeno[UZ_LEN];
    char heslo[PW_LEN];
    unsigned int heslo_I;
} type_uziv;

typedef struct {
    unsigned int cznak, uh_min;
    float znamka_presnost, znamka_cas, znamka, proc_chyb;
    unsigned int chyb, vterin;
} type_znamka;

typedef struct {
    char *vety;
    int pocet;
    char oddelovac;
} type_vety;

typedef enum {
    g_barva, g_warning, g_qwertz, g_us, g_run, g_box, g_disable_inet
} enum_global;

typedef enum {
    g_w_ne = 0, g_w_ano =
        1, g_q_y, g_q_z, g_us_us, g_us_cz, g_run_null, g_run_t,
    g_run_l, g_run_vt, g_null
} enum_global_stav;

#endif
