/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor vl_napoveda.c */

#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include <time.h>
#include <string.h>

#include "struktury.h"
#include "lib.h"

void *vl_napoveda3(void *arg)
{
    type_vety v = text_n3();
    static char text[255];
    int delka, i, j, veta;

    i = pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
    if (i && (global_get(g_warning) == g_w_ano)) {
        print_hl(1,
                 "vl_napoveda3: Selhalo nastaveni priznaku ukonceni funkce varovani");
        return NULL;
    }

    usleep(1000);               /* aby se varovani nezobrazovalo
                                   moc brzo po startu */
/*    strcpy(text, "Nelze nast soubor:\n");
    strncat(text, jmeno_napovedy3(),
	    sizeof(text) / sizeof(char) - strlen(text));
*/
    if (v.vety == NULL) {
/*   if (global_get(g_warning) == g_w_ano) */
        print_hl(2, "Nelze nast soubor:\n", jmeno_napovedy3());
        pthread_exit(0);
    }

    srand((unsigned) time(NULL));
    do {
        pthread_testcancel();
        sleep(15);
        if (global_get(g_run) != g_run_null)
            continue;

        veta = (rand() % v.pocet) + 1;
        delka = 0;
        i = j = 0;

        while ((delka < veta) && v.vety[i]) {
            if (v.vety[i++] == v.oddelovac)
                delka++;
        }
        if (!v.vety[i])
            continue;           /* veta pozadovaneho cisla */
        /* nebyla nalezena (teoret. nemozne!) */
        while (v.vety[i] && (v.vety[i] != v.oddelovac) && j < sizeof(text))
            text[j++] = v.vety[i++];

        text[j - 1] = '\0';     /* misto \n, proto [j-1] a ne jenom [j] */
        print_hl(1, text);
    }
    while (1);

    pthread_exit(0);
}
