/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor vyberlekci.c */

#include <limits.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"

int vyber_lekci(type_uziv * slozka, type_nastaveni * nastaveni, int MIN,
                int MAX)
{
    int i, ch;
    static int l;
    type_informace lekce;
    int napoveda = 0;

    obnov_nadpis1(slozka, nastaveni);

    if ((l < MIN) || (l > MAX))
        for (i = 0; i < MAX; i++)
            if (!slozka->napsano_lekce[i]) {
                if (i + 1 >= MIN)
                    l = i + 1;
                break;
            }
    if ((l < MIN) || (l > MAX))
        l = MIN;

    werase2(sub_informace);

    do {
        lekce = informace_o_lekcich(l, slozka);

        if (!napoveda)
            vypis_info(lekce, nastaveni);
        else
            vypis_napoveda(jmeno_napovedy_lekce(l), 0);

        for (i = MIN; i <= MAX; i++) {
            if (i == l)
                wattron2(sub_informace, /*A_BOLD */ A_REVERSE);
            MVWPRINTW2(sub_informace, i - MIN + 1, 1, "Lekce %02i", i);
            if (i == l)
                wattroff2(sub_informace, /*A_BOLD */ A_REVERSE);
        }

        obnov_informace();
        tiskni_dle_priority();

        ch = getch3();

        if (ch == '\t')
            napoveda = !napoveda;

        if (((ch == KEY_DOWN) || (ch == 'l')) && l < MAX)
            l++;
        else if (((ch == KEY_UP) || (ch == 'L')) && l > MIN)
            l--;

        if (ch == 'k' || ch == 'K')
            return 0;

        if (ch == '\n') {
            /* prinutime uzivatele si nejdrive precist napovedu */
            if (!napoveda) {
                napoveda = !napoveda;
            } else if (lekce.zavislost)
                return l;
            else {
                print_hl(1,
                         "Nejdve je nutn napsat pedchoz lekci nebo test !");
            }
        }
    }
    while (TRUE);

}
